using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace MenuTest
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        SpriteFont menuFont;
        SpriteBin Sprites;
        MenuManager mMenus;
        float mVolume;
        bool quit = false;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
            graphics.PreferredBackBufferWidth = 1080;
            graphics.PreferredBackBufferHeight = 720;
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
        }


        /// <summary>
        ///  CreateMenus creates the Main Menu and the Confirm Quit menu, and
        ///  activates the main menu.
        /// </summary>
        /// <param name="menuFont"></param>
        protected void CreateMenus(SpriteFont menuFont)
        {
            Menu mainMenu =  new Menu(menuFont, "Main Menu", true);
            Menu confirmQuit = new Menu(menuFont, "Quit?", false);
            mainMenu.AddMenuItem("Single Player Game", null);
            mainMenu.AddMenuItem("Two Player Game", null);
            mainMenu.AddMenuItem("Options", null);
            mainMenu.AddMenuItem("Quit", () => { confirmQuit.Enabled = true; mainMenu.Enabled = false; });
            confirmQuit.AddMenuItem("Yes", () => { this.Exit(); });
            confirmQuit.AddMenuItem("No", () => { confirmQuit.Enabled = false; mainMenu.Enabled = true; });

            /// Add a menu item for controlling the parameter mVolume.  Use the texture ScaleFull 
            
            
            mMenus = new MenuManager();
            mMenus.AddMenu(mainMenu);
            mMenus.AddMenu(confirmQuit);
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        /// 
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);
            menuFont = Content.Load<SpriteFont>("SpriteFont1");
            Sprites = new SpriteBin(menuFont);
            CreateMenus(menuFont);
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (quit == true)
                this.Exit();
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // TODO: Add your update logic here
            mMenus.Update(gameTime);
            KeyboardManager.GetInstance().Update(gameTime);
            base.Update(gameTime);
            AnimationManager.GetInstance().Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);

            spriteBatch.Begin();
            mMenus.Draw(spriteBatch);
            spriteBatch.DrawString(menuFont, "Volume = " + mVolume.ToString(), Vector2.Zero, Color.White);
            spriteBatch.End();

            base.Draw(gameTime);
        }
    }
}
